Home | History | Annotate | Download | only in rbind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test27} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST27***************"
     29 tst_resm TINFO "rbind: shared subtree with slave child to slave subtree."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of rbind/test27 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent1
     45 	"${FS_BIND_ROOT}/bin/makedir" priv parent2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 	"${FS_BIND_ROOT}/bin/makedir" share share2
     48 	"${FS_BIND_ROOT}/bin/makedir" share parent1/child1
     49 
     50 	mount --bind share1 parent1/child1
     51 	mount --bind share2 parent2
     52 	mount --rbind "$disk1" parent1/child1
     53 	"${FS_BIND_ROOT}/bin/makedir" slave parent1/child1
     54 	"${FS_BIND_ROOT}/bin/makedir" slave parent2
     55 
     56 	mount --rbind parent1 parent2
     57 
     58 	check parent1 parent2
     59 	check parent1/child1/ parent2/child1
     60 	check -n parent2 share2
     61 
     62 	mount --rbind "$disk2" parent1/child1/a
     63 
     64 	check -n parent1/child1/a parent2/child1/a
     65 	check -n parent1/child1/a share1/a
     66 
     67 	mount --rbind "$disk3" parent2/child1/b
     68 
     69 	check -n parent1/child1/b parent2/child1/b
     70 
     71 	break
     72 done
     73 trap 'ERR=$? ; tst_resm TWARN "rbind/test27: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     74 if [ -n "${ERR_MSG}" ]; then
     75 	tst_resm TWARN "rbind/test27: ${ERR_MSG}"
     76 	ERR_MSG=""
     77 	result=$ERR
     78 fi
     79 trap '' ERR
     80 {
     81 	umount parent1/child1/a
     82 	umount parent2/child1/b
     83 	umount parent2/child1
     84 	umount parent2/child1
     85 	umount parent1/child1
     86 	umount parent1/child1
     87 	umount parent2
     88 	umount parent2
     89 	umount parent2
     90 	umount share2
     91 	umount parent1
     92 
     93 	rm -rf parent* share*
     94 	cleanup
     95 } >& /dev/null
     96 if [ $result -ne 0 ]
     97 then
     98 	tst_resm TFAIL "rbind/test27: FAILED: rbind: shared subtree with slave child to slave subtree."
     99 	exit 1
    100 else
    101 	tst_resm TPASS "rbind/test27: PASSED"
    102 	exit 0
    103 fi
    104 tst_exit
    105